stages:
    - linter_staticAnalisis
    - unit_tester
    - coverage_tester
    
image: python:3.6

before_script:
    - pip install coverage
    - pip install pylint
    
pylint:
    stage: linter_staticAnalisis
    script:
        - echo "- . - Pylint - . -"
        - pylint myarray/basearray.py --errors-only
    
print_test:
    stage: unit_tester
    script:
        - echo "test izpis"
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_izpis
    artifacts:
        paths:
            - .coverage.*
        expire_in: 1 day
        
sort_test:
    stage: unit_tester
    script:
        - echo "test sortiranje"
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_sortiranje
    artifacts:
        paths:
            - .coverage.*
        expire_in: 1 day
        
search_test:
    stage: unit_tester
    script:
        - echo "test iskanje"
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_iskanje
    artifacts:
        paths:
            - .coverage.*
        expire_in: 1 day
        
functions_and_operations_test:
    stage: unit_tester
    script:
        - echo "test funkcij in operacij"
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_sestej
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_odstej
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_deli
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_logaritmiraj
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_potenciraj
        - coverage run -p -m unittest myarray.test_basearray.test_init_.test_mnozi
    artifacts:
        paths:
            - .coverage.*
        expire_in: 1 day
    
coverage_test:
    stage: coverage_tester
    script:
        - echo "- . - Pokritost - . -"
        - coverage combine
        - coverage report
        - coverage html
        - coverage html
    artifacts:
        paths:
            - htmlcov/
        expire_in: 1 day
    